/**
 * This file contains internal functions.
 *
 * DO NOT EDIT THIS FILE !
 */

/********************************************
 * Copyright (C) 2002-2007 Nina Marwede     *
 * Original download: http://lynax.de/map/  *
 * Version: 0.90 RC 1                       *
 ********************************************/

// requires map_cfg.js
// requires map_lang_XX.js
// required by map.js

var nameandversion = "Lynax' RPG-Map v0.90 RC 1";

var linefeed = "<br />";

var i, j, r, x, y, x1, x2, y1, y2;
var charinfo, posinfo, maxX, maxY, mouseX, mouseY, scrollX, scrollY, floatX, floatY, portraitstyle, tipstyle;
var lines, max_length, tooltip_height, tooltip_width;
var dragactive = false;
var showtooltip = false;
var showportrait = false;
var error = false;
var moz = false;
var op7 = false;
var ie4 = false;
var ie6strict = false;
var other = false;

var a_objects = new Array();
var a_className = new Array( extentY );
var a_innerHTML = new Array( extentY );
var a_title     = new Array( extentY );
for( i=0; i < extentY; i++ ){
  a_className[i] = new Array( extentX );
  a_innerHTML[i] = new Array( extentX );
  a_title[i]     = new Array( extentX );
}

if( top.frames.length )top.location.href=self.location;
document.onmousemove = mousemove;
document.writeln("<style type=\"text/css\">table{width:"+((extentX+2)*cellSizeX)+"px}td,td img{height:"+cellSizeY+"px;width:"+cellSizeX+"px}<\/style>");

function checkFile( filename, pos ){
  if( filename == '' ){
    if( debug )alert( "Error: You have to specify a valid filename for the item(s) at '" + pos + "'." );
    return 1;
  }
  return 0;
}

function checkPosition( x, y ){
  if( (x<1) || (x>extentX) || (y<1) || (y>extentY) ){
    if( debug && !error )alert( "Error: Index out of bound at " + String.fromCharCode(y+64) + x + ". Specify position between A1 and " + String.fromCharCode(extentY+64) + extentX + "!" );
    error = true;
    return 1;
  }
  return 0;
}

function checkRect( x1, y1, x2, y2 ){
  if( (x1>x2) || (y1>y2) ){
    if( debug )alert( "Error: " + String.fromCharCode(y1+64) + x1 + " should be more right and below than or equal to " + String.fromCharCode(y2+64) + x2 + "!" );
    return 1;
  }
  return 0;
}

function parsePositionX( pos ){
  x = parseInt( pos.substr(1), 10 );
  return isNaN(x) ? 0 : x;
}

function parsePositionY( pos ){
  y = pos.charCodeAt(0);
  return y>96 ? y-96 : y-64;
}

function maskApostroph( str ){
  return str.replace( /'/g, "\f" );  // "\\'" ?     "\v" doesn't work under IE55
}

function redoApostroph( str ){
  return str.replace( /\f/g, "'" );
}

function charInfoString( sep, name, weapon, condition, portrait, player ){
  return sep + lang_char_player + name + " (" + player + ")" + sep + lang_weapon + weapon + sep + lang_condition + condition + (portrait == "" ? "" : sep + lang_portrait_click);
}

function doOnMouseOver( x, y, icon, name, weapon, condition, portrait, player ){
  posinfo = typeof a_title[y-1][x-1] == "undefined" ? ( String.fromCharCode(y+64) + x + ": " ) : a_title[y-1][x-1];
  tooltip(        posinfo + redoApostroph( charInfoString( linefeed, name.bold(), weapon, condition, portrait, player ) ), icon );
  window.status = posinfo + redoApostroph( charInfoString( sb_sep,   name,        weapon, condition, portrait, player ) );
}

function doOnMouseOut(){
  tooltip('','');
  window.status = '';
}

function doOnMouseClick( portrait, name ){
  setPortrait( portrait, redoApostroph(name) );
}

function createMouseoverInfo( x, y, icon, name, weapon, condition, portrait, player ){
  return " onmouseover=\"doOnMouseOver("+x+","+y+",'"+icon+"','"+name+"','"+weapon+"','"+condition+"','"+portrait+"','"+player+"');\" onmouseout=\"doOnMouseOut();\"";
}

function createPortrait( portrait, name ){
  if( portrait == "" )return "";
//  return " onclick=\"window.open('img/" + portrait + "','_blank','height=" + port_height + ",location=no,menubar=no,resizable=no,scrollbars=no,status=no,toolbar=no,width=" + port_width + "')\"";
//  return " onclick=\"setPortrait('" + portrait + "')\" style='cursor:pointer'";
  return " onclick=\"doOnMouseClick('" + portrait + "','" + name + "')\" style='cursor:pointer'";
}

function setCharacter( pos, icon, name, weapon, condition, portrait, player ){
  x = parsePositionX( pos );
  y = parsePositionY( pos );
  if( checkPosition( x, y ) )return;
  if( checkFile( icon, pos ) )return;
  name = maskApostroph( name );
  weapon = maskApostroph( weapon );
  condition = maskApostroph( condition );
  player = maskApostroph( condition );
  a_innerHTML[y-1][x-1] = "<img src=\"img/" + icon + "\" " + createMouseoverInfo( x, y, icon, name, weapon, condition, portrait, player ) + createPortrait( portrait, name ) + " \/>";
}

function setObject( pos, icon, name, weapon, condition, portrait, player ){
  x = parsePositionX( pos );
  y = parsePositionY( pos );
  if( checkPosition( x, y ) )return;
  if( checkFile( icon, pos ) )return;
  name = maskApostroph( name );
  weapon = maskApostroph( weapon );
  condition = maskApostroph( condition );
  player = maskApostroph( condition );
  a_objects[a_objects.length] = "<div style=\"position:absolute;left:" + (x*cellSizeX) + "px;top:" + (y*cellSizeY) + "px\"><img src=\"img/" + icon + "\" " + createMouseoverInfo( x, y, icon, name, weapon, condition, portrait, player ) + createPortrait( portrait, name ) + " \/><\/div>";
}

function setTerrain( pos, terrain ){
  x = parsePositionX( pos );
  y = parsePositionY( pos );
  if( checkPosition( x, y ) )return;
  setTerrainXY( x, y, terrain );
}

function setTerrainXY( x, y, terr, except ){
  if( checkPosition( x, y ) )return;
  if( typeof terr == "undefined" || terr == '' )return;
  if( typeof except != "undefined" && a_className[y-1][x-1] == except )return;
  a_className[y-1][x-1] = terr;
  terr = typeof terrain[terr] == "undefined" ? a_className[y-1][x-1] : terrain[terr];
  a_title[y-1][x-1] = String.fromCharCode(y+64) + x + ": " + terr;
}

function setTerrainCircle( pos, r, terrain, except ){		// r has to be INT, float does not work
  x = parsePositionX( pos );
  y = parsePositionY( pos );
  if( checkPosition( x, y ) )return;
  r = parseInt( r );
  for( i = x-r; i <= x+r; i++ )for( j = y-r; j <= y+r; j++ )if( (i>0) && (i<=extentX) && (j>0) && (j<=extentY) && (Math.round(Math.sqrt((x-i)*(x-i)+(y-j)*(y-j)))==r) )setTerrainXY( i, j, terrain, except );
}

function setTerrainCircleFilled( pos, rad, terrain, except ){
  x = parsePositionX( pos );
  y = parsePositionY( pos );
  if( checkPosition( x, y ) )return;
  rad = parseFloat( rad );
  r = Math.round( rad );
  for( i = x-r; i <= x+r; i++ )for( j = y-r; j <= y+r; j++ )if( (i>0) && (i<=extentX) && (j>0) && (j<=extentY) && ( Math.sqrt( Math.pow(x-i,2) + Math.pow(y-j,2) )<=rad) )setTerrainXY( i, j, terrain, except );
}

function setTerrainCircleCorner( pos, r, terrain, except ){	// r has to be INT, float does not work
  x = parsePositionX( pos );
  y = parsePositionY( pos );
  if( checkPosition( x, y ) )return;
  r = parseInt( r );
  for( i = x-r; i <= x+r; i++ )for( j = y-r; j <= y+r; j++ )if( (i>0) && (i<=extentX) && (j>0) && (j<=extentY) && ( Math.round( Math.sqrt( Math.pow(x-i+0.5,2) + Math.pow(y-j+0.5,2) ) )==r) )setTerrainXY( i, j, terrain, except );
}

function setTerrainCircleCornerFilled( pos, rad, terrain, except ){
  x = parsePositionX( pos );
  y = parsePositionY( pos );
  if( checkPosition( x, y ) )return;
  rad = parseFloat( rad );
  r = Math.round( rad );
  for( i = x-r; i <= x+r; i++ )for( j = y-r; j <= y+r; j++ )if( (i>0) && (i<=extentX) && (j>0) && (j<=extentY) && (Math.sqrt( Math.pow(x-i+0.5,2) + Math.pow(y-j+0.5,2) )<=rad) )setTerrainXY( i, j, terrain, except );
}

function setTerrainRect( pos1, pos2, terrain, except ){
  x1 = parsePositionX( pos1 );
  y1 = parsePositionY( pos1 );
  x2 = parsePositionX( pos2 );
  y2 = parsePositionY( pos2 );
  if( checkPosition( x1, y1 ) )return;
  if( checkPosition( x2, y2 ) )return;
  if( checkRect( x1, y1, x2, y2 ) )return;
  for( i = x1; i <= x2; i++ )for( j = y1; j <= y2; j++ )if( (i==x1) || (i==x2) || (j==y1) || (j==y2) )setTerrainXY( i, j, terrain, except );
}

function setTerrainRectFilled( pos1, pos2, terrain, except ){
  x1 = parsePositionX( pos1 );
  y1 = parsePositionY( pos1 );
  x2 = parsePositionX( pos2 );
  y2 = parsePositionY( pos2 );
  if( checkPosition( x1, y1 ) )return;
  if( checkPosition( x2, y2 ) )return;
  if( checkRect( x1, y1, x2, y2 ) )return;
  for( i = x1; i <= x2; i++ )for( j = y1; j <= y2; j++ )setTerrainXY( i, j, terrain, except );
}

function setupMap(){
  browsercheck();
  document.title = maptitle + " - " + nameandversion;
  document.writeln("<div id='tip' style='font-size:"+tooltip_fontsize+"px'>&nbsp;<\/div>");
  document.writeln("<div id='portrait' style='height:"+(port_height+21)+"px;width:"+port_width+"px;position:fixed;left:40px;top:40px;'> \
	<h4 id='portraitheader' title='click to drag and move this window'> \
		<span id='portraittitle'>"+lang_portrait+"<\/span> \
		<span style='cursor:pointer;margin:0px;padding:0px;position:absolute;right:1px;top:0px;' title='click to close this window' onclick='hidePortrait()'>X<\/span> \
	<\/h4> \
	<p id='portraitimage'>...<\/p> \
	<\/div>");
  tipstyle = document.getElementById('tip').style;
  portraitstyle = document.getElementById('portrait').style;
  if( ie4 || ie6strict )
    portraitstyle.position = 'absolute';
  document.getElementById('portraitheader').onmousedown = new Function("ereignis", "attach(ereignis);");
  document.getElementById('portraitheader').onmouseup   = new Function("ereignis", "detach(ereignis);");
}

function createMap(){
  document.writeln("<table border='0' cellpadding='0' cellspacing='0' id='map'>");
  document.writeln("<colgroup width='"+cellSizeX+"' span='"+(extentX+2)+"' />");
  document.writeln("<tbody>");
  for( i=0; i < extentY+2; i++ ){
    r = "<tr>";
    for( j=0; j < extentX+2; j++ )
      if( (j==0) || (j==extentX+1) ){
        if( (i==0) || (i==extentY+1) )r += "<td>&nbsp;<\/td>";				// corners
        else r += "<td class='border'><b>"+String.fromCharCode(i+64)+"<\/b><\/td>";	// vertical edge
      }else{
        if( (i==0) || (i==extentY+1) )r += "<td class='border'><b>"+j+"<\/b><\/td>";	// horizontal edge
        else r += "<td class="+a_className[i-1][j-1]+" title='"+a_title[i-1][j-1]+(typeof a_innerHTML[i-1][j-1]=="undefined"?"'>&nbsp;<\/td>":("'>"+a_innerHTML[i-1][j-1]+"<\/td>"));
      }
    document.writeln(r+"<\/tr>\n");
  }
  document.writeln("<\/tbody><\/table>");
  for( i=0; i < a_objects.length; i++ )document.writeln(a_objects[i]);
}

function browsercheck(){
  if( document.all ){
    if( window.innerWidth )
      op7 = true;
    else if( document.documentElement && document.documentElement.clientWidth )
      ie6strict = true;
    else if( document.body )  // attention: poll this AFTER <body> !
      ie4 = true;
    else
      other = true;
  }else{
    if( window.innerWidth )
      moz = true;
    else
      other = true;
  }
}

function getMouseCoords(e){
  if( moz || op7){
    scrollX = window.pageXOffset;
    scrollY = window.pageYOffset;
    maxX = window.innerWidth;
    maxY = window.innerHeight;
  }
  if( ie4 ){
    scrollX = document.body.scrollLeft;
    scrollY = document.body.scrollTop;
    maxX = document.body.clientWidth;
    maxY = document.body.clientHeight;
  }
  if( ie6strict ){
    scrollX = document.documentElement.scrollLeft;
    scrollY = document.documentElement.scrollTop;
    maxX = document.documentElement.clientWidth;
    maxY = document.documentElement.clientHeight;
  }
  if( document.all ){								// IE + Opera
    mouseX = window.event.x + scrollX;
    mouseY = window.event.y + scrollY;
  }else{									// Mozilla
    mouseX = e.pageX;
    mouseY = e.pageY;
  }
}

function mousemove(e) {
  if( showtooltip || dragactive ){
    getMouseCoords(e);
  }
  if( showtooltip ){
    tipstyle.left = ( mouseX+tooltip_width -scrollX+45 < maxX ? mouseX+20 : mouseX-tooltip_width -20 ) + 'px';
//  tipstyle.top  = ( mouseY+tooltip_height-scrollY+60 < maxY ? mouseY+40 : mouseY-tooltip_height-15 ) + 'px';
    tipstyle.top  = ( mouseY-tooltip_height-scrollY-15 < 0    ? mouseY+30 : mouseY-tooltip_height-10 ) + 'px';
    tipstyle.visibility = 'visible';
  }else{
    tipstyle.visibility = 'hidden';
  }
  if( dragactive ){
    if( mouseX < 0 )mouseX = 0;
    if( mouseY < 0 )mouseY = 0;
    portraitstyle.left = parseInt( portraitstyle.left ) + mouseX - floatX + "px";
    portraitstyle.top  = parseInt( portraitstyle.top  ) + mouseY - floatY + "px";
    floatX = mouseX;
    floatY = mouseY;
  }
}

function setTooltipExtent(text){
  lines = text.split(linefeed);
  max_length = 0;
  for( i=0; i<lines.length; i++ ){
    if( i==1 )
      lines[i] = lines[i].replace( /<(.|)b>/g, "" );	// remove <b> and </b>
    if( lines[i].length > max_length )
      max_length = lines[i].length;
  }
  tooltip_height = Math.max( Math.round( lines.length * tooltip_fontsize * 1.18 + 5 ), (cellSizeY*2+4) );
//  tooltip_width  = Math.round( max_length   * tooltip_fontsize * 0.45 + 4 ) + (cellSizeX*2+6);	// for sans-serif
  tooltip_width  = Math.round( max_length   * tooltip_fontsize * 0.65 + 0.5 ) + (cellSizeX*2+6);	// for monospace
  tipstyle.height = tooltip_height + 'px';
  tipstyle.width  = tooltip_width  + 'px';
}

function tooltip(text, icon){
  setTooltipExtent(text);
  document.getElementById('tip').innerHTML = '<img src="img/' + icon + '" alt="" style="height:'+(cellSizeY*2)+'px;width:'+(cellSizeX*2)+'px" \/><p style="margin:0px 0px 0px '+(cellSizeX*2+6)+'px">'+text+'</p>';
  showtooltip = text != '';
  tipstyle.visibility = showtooltip ? 'visible' : 'hidden';
}

function attach(e){
  getMouseCoords(e);
  floatX = mouseX;
  floatY = mouseY;
  dragactive = true;
}

function detach(e){
  dragactive = false;
}

function hidePortrait(){
  portraitstyle.visibility = 'hidden';
}

function setPortrait( portrait, title ){
  document.getElementById('portraittitle').innerHTML = title;
  document.getElementById('portraitimage').innerHTML = '<img src="img/' + portrait + '" alt="'+title+'" style="height:'+port_height+'px;width:'+port_width+'px;" \/>';
  portraitstyle.visibility = 'visible';
}


// for backwards compatibility

function setTerrainCircleSolid( pos, rad, terrain, except ){
  setTerrainCircleFilled( pos, rad, terrain, except );
}

function setTerrainCircleCross( pos, r, terrain, except ){
  setTerrainCircleCorner( pos, r, terrain, except );
}

function setTerrainCircleSolidCross( pos, rad, terrain, except ){
  setTerrainCircleCornerFilled( pos, rad, terrain, except );
}
